#include <bits/stdc++.h>
using namespace std;

int N = 1e6+15;

bool is_command(char c) {
    switch (c) {
        case '>': case '<': case '+': case '-':
        case '.': case ',': case '[': case ']': return true;
        default: return false;
    }
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n >> ws;

    string s;
    getline(cin, s);

    vector<char> command (N);
    vector<string> comment (N, "");
    vector<int> comment_before (N+1, 0);

    int m;
    {
        int j = 0;
        for (int i = 0; i < n; i++) {
            if (is_command(s[i])) {
                command[j++] = s[i];
            } else if (s[i] != ' ') {
                int l = i;
                while (i+1 < n && !is_command(s[i+1])) { i++; }
                int r = i+1;
                while (s[r-1] == ' ') { r--; }
                comment[j-1] = " " + s.substr(l, r-l) + "\n";
                comment_before[j] = +1;
            }
        }
        m = j;
    }

    partial_sum(comment_before.begin(), comment_before.end(), comment_before.begin());

    vector<int> indentation (N, 0);
    {
        stack<int> S;
        for (int i = 0; i < m; i++) {
            if (command[i] == '[') {
                S.push(i);
            } else if (command[i] == ']') {
                int l = S.top(); S.pop();
                int r = i;

                if (comment_before[r] > comment_before[l]) {
                    indentation[l+1]++;
                    if (l-1 >= 0 && comment[l-1] == "") { comment[l-1] = "\n"; }
                    if (comment[l] == "") { comment[l] = "\n"; }
                    indentation[r]--;
                    if (comment[r-1] == "") { comment[r-1] = "\n"; }
                    if (comment[r] == "") { comment[r] = "\n"; }
                }
            }
        }
    }

    partial_sum(indentation.begin(), indentation.end(), indentation.begin());

    for (int i = 0; i < m; i++) {
        if (i == 0 || comment[i-1] != "") {
            cout << indentation[i] << " ";
        }
        cout << command[i] << comment[i];
    }
}
